<template>
  <v-container fluid>
    <div class="dashboard-page">
      <v-row no-gutters class="d-flex justify-space-between mt-10 mb-6">
        <h1 class="page-title">{{ programStore.program.educationProgram.name }}</h1>
        <v-col cols="2">
        <v-select
          v-model="select2"
          :items="selectItems2"
          item-text="name"
          item-value="code"
          persistent-hint
          return-object
          outlined
        >
        </v-select>
        </v-col>
        <v-col cols="2">
        <v-select
          v-model="select"
          :items="selectItems"
          item-text="name"
          item-value="code"
          persistent-hint
          return-object
          outlined
        >
        </v-select>
        </v-col>
      </v-row>

      <v-row>
        <v-col lg=5 sm=6 md=5 cols=12>
          <v-card class="mx-1 mb-1">
            <v-card-title class="pa-6 pb-3">
              <p>Предметы для поступления:</p>
              <v-spacer></v-spacer>
            </v-card-title>
            <v-card-text
              class="pa-6 pt-0"
              >
              <v-list>
              <v-list-item
                v-for="(item, i) in requiredSubjects"
                :key="i"
              >
                  <v-list-item-title>
                  {{ item.name }}
                </v-list-item-title>
                <v-list-item-subtitle>
                  {{ item.value }}
                </v-list-item-subtitle>
              </v-list-item>
            </v-list>
            </v-card-text>
          </v-card>
        </v-col>
        <v-col lg=7 sm=6 md=5 cols=12>
          <v-card class="mx-1 mb-1">
            <v-card-title class="pa-6 pb-3">
              <p>Документы для подачи:</p>
              <v-spacer></v-spacer>
            </v-card-title>
            <v-card-text class="pa-6 pt-0">
              <v-list>
                <v-list-item
                v-for="item in requiredDocuments"
                :key="item.name"
              >
                <v-list-item-title>{{ item.name }}</v-list-item-title>
              </v-list-item>
              <v-list-item
                v-for="(item, i) in documents"
                :key="i"
                @click="item.link">
                <v-list-item-title>{{ item.name }}</v-list-item-title>
                <v-list-item-icon>
                  <v-icon>open_in_new</v-icon>
                </v-list-item-icon>
              </v-list-item>
            </v-list>
            </v-card-text>
          </v-card>
        </v-col>
        <v-col cols=12>
          <v-card class="mx-1 mb-1">
              <rate-table
                :loading="isLoading"
                :rates="programStore.rates"
                :requiredSubjects="requiredSubjects"
                :placesCount="this.placesCount"
              ></rate-table>
            </v-card>
        </v-col>
      </v-row>
    </div>
  </v-container>
</template>

<script lang="ts">
import Vue from 'vue';
import { Component, Prop, Watch } from 'vue-property-decorator';
import ApplicationModule from '@/store/modules/application';
import { getModule } from 'vuex-module-decorators';
import ProgramCard from '@/components/ProgramCard/ProgramCard.vue';
import RateTable from '@/components/RateTable/RateTable.vue';
import ProgramModule from '@/store/modules/programs';
import GraduationModule from '@/store/modules/graduations';
import { Code, IDirection, IRateParams, ISubject } from '@/interfaces';
import ApexChart from 'vue-apexcharts';


@Component({components: {RateTable, ApexChart}})
export default class EducationProgram extends Vue {
  private programStore = getModule(ProgramModule, this.$store);
  private apexSelect = ['Daily', 'Weekly', 'Monthly'];
  private select = { name: '2020', code: 2020 };
  private selectItems = [
    { name: '2020', code: 2020 },
    { name: '2019', code: 2019 },
  ];
  private select2 = { name: 'Бюджет', code: 'federal' };
  private selectItems2 = [
    { name: 'Бюджет', code: 'federal' },
    { name: 'Контракт', code: 'contract' },
  ];
  private mainApexAreaSelect = 'Daily';

  private isLoading = true;
  private documents = [
    {
      name: 'Заявление поступающего',
      link: 'http://technolog.edu.ru/files/147/2020/бланк_заявления_2020_2.pdf',
    },
    {
      name: 'Согласие на обработку личных данных (до 18 лет)',
      link: 'http://technolog.edu.ru/files/147/2020/персональные_данные_до_18.pdf',
    },
  ];

  private requiredDocuments = [
    {name: 'Аттестат или диплом'},
    {name: '2 фото 3х4'},
    {name: 'Копия паспорта'},
  ];

  @Watch('select')
  public onSelectChanged(newVal: Code) {
    const params: IRateParams = {
      year: Number(newVal.code),
      direction: this.select2.code,
      programInstanceId: this.programStore.program.id,
    };
    this.programStore.fetchRate(params);
  }

  @Watch('select2')
  public onSelect2Changed(newVal: Code) {
    const params: IRateParams = {
      year: this.select.code,
      direction: newVal.code,
      programInstanceId: this.programStore.program.id,
    };
    this.programStore.fetchRate(params);
  }

  protected get pageId(): number {
    return parseInt(this.$route.params.id, 0);
  }

  protected get direction(): IDirection | undefined {
    const directions = this.programStore.program.directions.filter(
      (x: IDirection) => x.year === this.select.code && x.code === this.select2.code,
    );

    if (directions.length > 0) {
      return directions[0];
    }
  }

  protected get placesCount(): number {
    return this.direction === undefined ? 0 : this.direction.placesCount;
  }

  protected get requiredSubjects(): ISubject[] {
    if (this.direction !== undefined) {
      return this.direction.requiredSubjects;
    }
    return [];

  }
  protected created() {
    const params: IRateParams = {
      year: this.select.code,
      direction: this.select2.code,
      programInstanceId: this.programStore.program.id,
    };

    this.programStore.fetchProgram(this.pageId);
    this.programStore.fetchRate(params);
    this.isLoading = false;
  }

  private openLink(link: string) {
    window.open(link, '_blank');
  }
}
</script>
